#include "RainbowThermometer.h"
#include <stdio.h>

static FILE outf = {0};

static int ser_putchar(char c, FILE* stream){
  Serial.write(c);
  return 0;
}

rTherm::rTherm(int common_anode){
  // setup pins and serial port
  thermPowerPin = 13;
  commonPin = 4;

  enablePin = 7;

  commonAnode = 0;
  sensor = A0;
  commonAnode = common_anode; //save
  
  A = pow(e, -BETA / 298.15) * 10e3;

  rLedPin = 3;
  if (common_anode){
    gLedPin = 5;
    bLedPin = 6;
  } else {
    gLedPin = 6;
    bLedPin = 5;
  }
   
  pinMode(rLedPin, OUTPUT);
  pinMode(gLedPin, OUTPUT);
  pinMode(bLedPin, OUTPUT);
  pinMode(commonPin, INPUT);
  pinMode(enablePin, OUTPUT);
  pinMode(thermPowerPin, OUTPUT);
  
  pinMode (sensor, INPUT);
  
  digitalWrite (rLedPin, HIGH);
  digitalWrite (gLedPin, HIGH);
  digitalWrite (bLedPin, HIGH);
  if (commonAnode){
      digitalWrite (enablePin, HIGH);
  } else {  
      digitalWrite (enablePin, LOW);
  }

  digitalWrite (thermPowerPin, LOW);
  
  fdev_setup_stream(&outf, ser_putchar, NULL, _FDEV_SETUP_WRITE);
  stdout = &outf;
    
}
void rTherm::enableSensor(){
  digitalWrite(thermPowerPin, HIGH);
  delay(5);
}
void rTherm::disableSensor(){
 digitalWrite(thermPowerPin, LOW);   
}
void rTherm::setLed(int colors[3]){
    if (commonAnode){
      analogWrite(rLedPin,255-colors[0]);
      analogWrite(gLedPin,255-colors[1]);
      analogWrite(bLedPin,255-colors[2]);
    }else{
      analogWrite(rLedPin,colors[0]);
      analogWrite(gLedPin,colors[1]);
      analogWrite(bLedPin,colors[2]);
    }
}
